# How to Contribute to InfiniteOpt
Welcome! This document explains some of the ways you can contribute to InfiniteOpt.

## Code of Conduct
This project and everyone participating in it is governed by the
[InfiniteOpt Code of Conduct](https://github.com/pulsipher/InfiniteOpt.jl/blob/master/CODE_OF_CONDUCT.md).
By participating, you are expected to uphold this code.

## Improve the Documentation
Our documentation is by no means perfect, and we welcome help in making it better.
Chances are if you have had to ask us questions, then our
[documentation](https://pulsipher.github.io/InfiniteOpt.jl/dev/) can be improved
and moreover you're probably the best person to help since it was your question.

The docs are written in Markdown and are built using [Documenter.jl](https://github.com/JuliaDocs/Documenter.jl).
You can find the source code to of all the docs [here](https://github.com/pulsipher/InfiniteOpt.jl/tree/master/docs/src).

If your change is small (like fixing typos, or one or two sentence corrections),
the easiest way to do this is via Github's online editor. (Github has
[help](https://help.github.com/articles/editing-files-in-another-user-s-repository/)
on how to do this.) Moreover, the editor can be activated on the page of interest
by clicking on the `Edit on GitHub` button at the top of the documentation page.

If your change is larger, or touches multiple files, you will need to make the
change locally and then use Git to submit a pull request. (See our [Development](https://pulsipher.github.io/InfiniteOpt.jl/dev/develop/start_guide)
page for more information and for the step by step explanation.)

Also, feel free to [ask a question](https://github.com/pulsipher/InfiniteOpt.jl/issues/new?assignees=&labels=question&template=i-have-a-question.md&title=%5BHelp+Wanted%5D+My+Question).

## File a Bug Report
Another way to contribute to InfiniteOpt is to file [bug reports](https://github.com/pulsipher/InfiniteOpt.jl/issues/new?assignees=&labels=bug&template=bug-report.md&title=%5BBUG%5D+My+Issue+Here).
Make sure you read the info in the box where you write the body of the issue
before posting.

## File a Feature Request
Another way to contribute is to let us know of something you would like added
and/or changed in InfiniteOpt. To do this please see [feature requests](https://github.com/pulsipher/InfiniteOpt.jl/issues/new?assignees=&labels=enhancement&template=feature-request.md&title=%5BFEATURE%5D+My+Desired+Feature+Here).
Please make sure you read the info and complete the template before posting.

## Contribute InfiniteOpt's Source-Code
Finally, you can also contribute code to InfiniteOpt!

If you do not have experience with Git, Github, and Julia development, the first
steps can be a little daunting. However, there are lots of tutorials available
online to help you get started. Please visit our [developer docs](https://pulsipher.github.io/InfiniteOpt.jl/dev/develop/start_guide)
to walk you through getting started.

Once you are familiar with Git, the workflow for contributing code to InfiniteOpt
is along the lines of the following:
1. Find an [open issue](https://github.com/pulsipher/InfiniteOpt.jl/issues) (or open a
    new one) for the problem you want to solve
2. Make your changes locally. (Again our RoadMap explains this). Make sure you:
    - Follow the [style guide](https://pulsipher.github.io/InfiniteOpt.jl/dev/develop/style)
    - Add tests and documentation for any changes or new features
3. Submit a pull request to Github
4. Update your pull request, responding to any comments

Remember to be patient and polite; you may get a _lot_ of comments on your pull
request! However, do not be afraid! A lot of comments means that people are
willing to help you improve the code that you are contributing to InfiniteOpt.

Thank you for contributing to InfiniteOpt, you're help is greatly valued and
appreciated!
